/*
///////////////////////////////////////////////////////////////////////////////////////////////////
//
//	FileName	lcd.c
//	Version		1.00
//	MCU		R8C/2B
//	Work		
//-------------------------------------------------------------------------------------------------
//
//	2008/05/30	Ver1.00
//-------------------------------------------------------------------------------------------------
//ldln
//	LCDɕ\vOłB
//	莞Ԃŕ\镶ς܂B
//-------------------------------------------------------------------------------------------------
///////////////////////////////////////////////////////////////////////////////////////////////////
/*

̃\tgEFA̓t[EFAłB

̃\tgEFAɊւ鎿ɂ܂ẮA
T|[g̑ΏۊOƂȂ܂B

쌠͍쐬ł()kldqL̂Ƃ܂B

̃\tgEFAgpƂɂSĂ̑QɂāA
쐬͈؂̐ӔC𕉂Ȃ̂Ƃ܂B

̃\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ
֎~܂BGȂǂ֏ЉE^̏ꍇ͘A肢v
܂B

@Copyright (C) Hokuto denshi Co,Ltd. 2008

*/
///////////////////////////////////////////////////////////////////////////////////////////////////
/* CN[ht@C錾 */

#include "R8C_2A_2B.h"

///////////////////////////////////////////////////////////////////////////////////////////////////
/* ^錾 */

///////////////////////////////////////////////////////////////////////////////////////////////////
/* ϐ錾 */

unsigned int x, y;

///////////////////////////////////////////////////////////////////////////////////////////////////
/* ֐̃vg^Cv錾 */

void set_CLK(void);
void init_IO(void);
void main(void);
void wait(unsigned long msec);

void Wait_LCD ( const unsigned long Interval );
void Init_LCD ( void );
void Write_LCD (const unsigned char RS_Mode ,const unsigned char Data);
void Locate_LCD ( const unsigned char X, const unsigned char Y );
void Clear_LCD ( void );
void Print_LCD ( const char *String );

///////////////////////////////////////////////////////////////////////////////////////////////////
/* I/OCvbg */

void init_IO(void)
{
	PRCR = 0x0f;		// veNgWX^
	PD5 = 0xff;		// LCD_04~07
	PD6 = 0x03;		// LCD_E,LCD_RS
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* NbNZbg */

void set_CLK(void)
{
/* ONbN20MHz */
	CM1 = 0x08;
	CM0 = 0x14; 
	OCD = 0x00; 
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD */

void Init_LCD ( void )
{
	P5 = 0x00;
	P6 = 0x00;

	Wait_LCD ( 20 );

	P6 = P6 & ~0x02;		// RS Low Set

	/* LCD1 */
	P6 = P6 | 0x01;			// E High Set
	P5 = ( P5 & 0xf0 ) | 0x03;	// MM1
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );
	Wait_LCD ( 5 );

	/* LCD2 */
	P6 = P6 | 0x01;			// E High Set
	P5 = ( P5 & 0xf0 ) | 0x03;	// MM2
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );

	/* LCD3 */
	P6 = P6 | 0x01;			// E High Set
	P5 = ( P5 & 0xf0 ) | 0x03;	// MM3
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );

	/* LCD4 */
	P6 = P6 | 0x01;			// E High Set
	P5 = ( P5 & 0xf0 ) | 0x02;	// MM4
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );

	/* t@NVZbgF4rbgoXA2sA5~7hbg */
	Write_LCD ( 0 , 0x28 );

	/* Gg[[hFJ[\CNgAJ[\ړ */
	Write_LCD ( 0 , 0x06 );

	/* J[\/\VtgFJ[\EVtg */
	Write_LCD ( 0 , 0x10 );

	/* \ON/OFFRg[FfBXvC\AJ[\\AuN\ */
	Write_LCD ( 0 , 0x0d );

	/* \NA */
	Clear_LCD ();

	Wait_LCD ( 5 );
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD\ */

void Write_LCD (
	const unsigned char RS_Mode ,
	const unsigned char Data
)
{
	/* 4rbg̏ꍇ */
	/* RS Setting */
	if ( RS_Mode == 0 )
	{
		P6 = P6 & ~0x02;	// RS Low Set
	}
	else if ( RS_Mode == 1 )
	{
		P6 = P6 | 0x02;		// RS High Set
	}

	/* 4rbg */
	P6 = P6 | 0x01;			// E High Set

	P5 = ( P5 & 0xf0 ) | (( Data >> 4 ) & 0x0f );	// 4rbg
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );

	/* 4rbg */
	P6 = P6 | 0x01;			// E High Set

	P5 = ( P5 & 0xf0 ) | (  Data & 0x0f );		// 4rbg
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD J[\ړ */
	
void Locate_LCD ( const unsigned char X, const unsigned char Y )
{
	unsigned char i;
	i = Y * 0x40 + X;
	i = i | 0x80;

	Write_LCD( 0 , i );
	Wait_LCD ( 1 );

	/* J[\ۑ */
	x = X;
	y = Y;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD NA\ */
	
void Clear_LCD ( void )
{
	P6 = P6 & ~0x02;		// RS Low Set
	Write_LCD ( 0 , 0x01 );
	Wait_LCD ( 2 );
	Locate_LCD ( 0 , 0 );
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* EFCg */

void wait(unsigned long msec)
{
	unsigned long i;
	for(i=0; i<1000*msec; i++);
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* EFCgLCD */

void Wait_LCD ( const unsigned long Interval )
{
	volatile unsigned long i;
	for ( i = 0; i < Interval * 1000; ++i );
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD\ */

void Print_LCD ( const char *String )
{
	unsigned char i, j;
	
	/* \[v */
	for ( i = 0; String[ i ] != '\0'; ++i )
	{
		/* ` */
		if (
			( String[ i ] >= 0x20 && String[ i ] <= 0x7f ) ||
			( String[ i ] >= 0xa1 && String[ i ] <= 0xfd )
		)
		{/* kbcR[h͈͓̔̏ꍇ */
			/* ` */
			Write_LCD ( 1, String[ i ] );
			Wait_LCD ( 1 );
			
		/* J[\ړ */
			if ( x ==  16 - 1 )
			{/* 16sI[o[ꍇ */
				x = 0;
				y = ( y == 0 ? 1 : 0 );
				Locate_LCD ( x, y );
			}
			else
			{/* 16sȓ̏ꍇ */
				++x;
				Locate_LCD ( x, y );
			}
		}
		else if ( String[ i ] == '\n' )
		{/* sR[h̏ꍇ */
			x = 0;
			y = ( y == 0 ? 1 : 0 );
			Locate_LCD ( x, y );
		}
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* C */

void main()
{		
	unsigned char m_Str1[] = "Tiny I/O 2\nDEMO PROGRAM";
	unsigned char m_Str2[] = "LCD DEMO PROGRAM(CPU:R8C/2A_2B)";
	unsigned char m_Str3[] = "Base Board\nBB64S8C2A";
	unsigned char m_Str4[] = "HOKUTO DENSHI\nMADE IN JAPAN";
	
	init_IO();	// I/OCvbg
	set_CLK();	//NbNZbg
	Init_LCD ();	// LCD
	
	while(1)
	{
		Clear_LCD ();
		Print_LCD ( m_Str1 );
		wait(1000);
		Clear_LCD ();
		Print_LCD ( m_Str2 );
		wait(1000);
		Clear_LCD ();
		Print_LCD ( m_Str3 );
		wait(1000);
		Clear_LCD ();
		Print_LCD ( m_Str4 );
		wait(1000);
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
